/*
 * ana_dump.c
 *
 * Date         : 29/10/2001
 * Author       : Akihiro Asahara (asahara@cr.scphys.kyoto-u.ac.jp)
 * version      : 0.9
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "chess_local.h"
#include "read_module.h"

void ana_dump(int *idata, int *iheader)
{
  int i;

  struct vme_time vtime;
  int daqflag;
  struct gps_time gtime;

  int scal_c[9],scal_r[9];
  short scalflag;

  int tko[46];
  short tkoflag=0;

  int adc[3];
  short adcflag;

  struct tdcdata tdc[256];
  short tdcflag;
  int tdc_length=0;

  printf("------\n");
  
 /* header */

  printf("iheader = ");
  for(i=0;i<6;i++){
	printf("%d ",iheader[i]);
  }
  printf("\n");

 /* Trigger flag (GPS ? or event ?) */

  daqflag = idata[3] & 0x3;
  if(daqflag == 1)printf("EVENT trig\n");
  else            printf("GPS   trig\n");

 /* Sytem time  */

  systime_read(idata,&vtime);
  printf("\nsystem time = %d:%d:%d  tv_sec=%d tv_usec=%d\n"
		 ,vtime.hh,vtime.ml,vtime.ss,vtime.tv_sec,vtime.tv_usec);
  
 /* GPS  */

  gps_read(idata,&gtime);
  printf("\nGPS time = %x/%x/%x %x:%x:%x.%04x\n"
		 ,gtime.yy,gtime.mm,gtime.dd,
		 gtime.hh,gtime.ml,gtime.ss,gtime.msec);

 /* SCAL */

  printf("\n");
  scal_read(idata,scal_r,scal_c);
  
  for(i=0;i<8;i++)	printf("repic scaler[%d] = %d\n",i,scal_r[i]);
  for(i=0;i<9;i++)	printf("caen  scaler[%d] = %d\n",i,scal_c[i]);

 /* TKO scal */
  
  tdcflag = tko_read(idata,tko);
  printf("\nTKO flag = %d\n",tdcflag);

  if(tdcflag){
	for(i=1;i<=PMT_NUM;i++){
	  printf("TKO scaler[%d] = %d\n",i,tko[i]);
	}
  }

 /* ADC */

  printf("\nADC flag = %d\n",adc_read(idata,adc));
  for(i=0;i<3;i++){
	printf("adc[%d] = %d\n",i,adc[i]);
  }
  
 /* TDC */

  printf("\nTDC flag = %d\n",tdc_read(idata,tdc,&tdc_length));
  for(i=0;i<(tdc_length-1);i++){
	printf("tdc[%2d]: channel=%2d edge=%d time=%d\n"
		   ,i,tdc[i].channel,tdc[i].edge,tdc[i].time);
  }

  return;
}
