#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "/usr/local/lheasoft/SunOS_5.6_sparc/include/fitsio.h"

#define MAX_LENGTH   400
#define BINARY_EXT   2

void seqread_exec(char *filename, int dflg)
{
  fitsfile *fptr;

  int status;
  int hdunum,hdutype;
  long nrows;

  int i,length;

  int nulval,word[10],anynul;

  int loop=0;
  long current=1;
  int iheader[10];
  int idata[MAX_LENGTH];

  fits_open_file(&fptr, filename, READONLY, &status);
  if(status){
	printf("fits_open_file: status=  %d \n",status);
	exit(1);
  }

  hdunum = BINARY_EXT;
  fits_movabs_hdu(fptr, hdunum, &hdutype, &status);
  if(status){
	printf("fits_movavs_hdu: status=  %d \n",status);
	exit(1);
  }

  fits_get_num_rows(fptr,&nrows,&status);
  if(status){
	printf("fits_get_num_rows: status=  %d \n",status);
	exit(1);
  }

  while ((current+6) < nrows){

    loop++;
    if (!(loop%10000)){
      printf("loop %d times...done\n",loop);
    }

	for(i=0;i<6;i++){
	  fits_read_col(fptr, TINT, 1, current, 1,
					1, &nulval, word, &anynul, &status);
	  if(status){
		printf("fits_read_col(1): status=  %d \n",status);
		exit(1);
	  }
	  iheader[i] = word[0];
	  current++;
	}

	length = iheader[0];

	for(i=6;i<length;i++){
	  fits_read_col(fptr, TINT, 1, current, 1,
					1, &nulval, word, &anynul, &status);
	  if(status){
		printf("fits_read_col(2): status=  %d \n",status);
		exit(1);
	  }
	  idata[i-6] = word[0];
	  current++;
	}

    if (iheader[1]!=0) continue;

	if(dflg) ana_dump(idata,iheader);
	else     ana_exec(idata,iheader);
  }

  return;

}
