/*
 * Data analysis program "SYOGI (Show YOur data to GIvers)"
 * Introduction : This is the analysis program for CheSS
 * Date         : 29/10/2001
 * Author       : Akihiro Asahara (asahara@cr.scphys.kyoto-u.ac.jp)
 * version      : 0.9
 */

/*
 * syogi.c -- hlimit_trans.f -- ana_init.c -- seqread_exec.c -- ana_end.c
 *                                                  |
 *												   ana_exec.c
 *												   ana_dump.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

void seqread_exec(char *filename, int dflg);
void ana_init();
void ana_end(char *string);

main(int argc,char **argv)
{
  int ch,f_num,status;
  char prename[100];
  char filename[100];
  char num[30];
  char dest_dir[100];
  char outfile[100];
  int start,end;
  int dflg=0;
  int oflg=0;
  int iflg=0;
  extern char *optarg;
  extern int optind;
  int optnum=3;

  strcpy(dest_dir, "");
  strcpy(outfile, "default");

  while( (ch=getopt(argc, argv, "di:o:")) != EOF ){
	switch( ch ){
	case 'd' :
	  optnum++;
	  dflg++;
	  break;
	case 'i' :
	  optnum+=2;
	  iflg++;
	  strcpy(dest_dir, optarg);
	  break;	
	case 'o' :
	  optnum+=2;
	  oflg++;
	  strcpy(outfile, optarg);
	  break;	
	default  : break;
    }
  }
  if(argc != optnum) {
	(void)fprintf(stderr,
				  "usage: syogi [-d] [-i <dest DIR>] [-o <outputfile>] <start flame> <end flame>\n");
	exit (2);
  }
  
  start = atoi(argv[optind++]);
  end   = atoi(argv[optind]);
  if(start > end){
	(void)fprintf(stderr,
				  "input error: start flame > end flame\n");
	exit(2);
  }

  if (strcmp(dest_dir,"") == 0) {
	strcpy(prename,"CHSQ9");
  }
  else { 
	strcpy(prename, dest_dir);
	strcat(prename, "/");
	strcat(prename, "CHSQ9");
  }
  
  printf("\nNow open flame %d to %d.( dest_DIR= %s )\n"
		 ,start,end,dest_dir);

  if(!dflg){
	hlimit_trans_();
	ana_init();
  }
  
  for(f_num=start; f_num<=end; f_num++){
	
	strcpy(filename, prename);
	sprintf(num,"%7.7d",f_num);
	strcat(filename, num);
	strcat(filename, ".fits");
	
	printf("\nopening %s...\n", filename); 
	
	seqread_exec(filename,dflg);
  }
  
  strcat(outfile, ".hbk");
  if(!dflg) ana_end(outfile);
  
  printf("\nAll done.\n");
  
  exit(0);
}
